/*
 * Copyright (C) 2021 B.R.S. Roso.
 * 
 * Xselection is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License version 3 as published by the Free
 * Software Foundation.
 * 
 * This program is distributed in the hope that it be useful but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * Xselection.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef LMEM_H
#define LMEM_H

/* NB: For the correct behaviour of these functions, it's vital that there be
 * no other code in the process using mlock or munlock on the heap */ 

#include <stddef.h>

struct lmem {
	void *mem;
	size_t size;
};

int lmalloc(struct lmem *ret, size_t len);
int ldestroy(struct lmem *mem);
int lrealloc(struct lmem *mem, size_t new_len);
int lnew(struct lmem *ret);
int lgrow(struct lmem *mem);

#endif
