/*
 * Copyright (C) 2021 B.R.S. Roso.
 * 
 * Xselection is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License version 3 as published by the Free
 * Software Foundation.
 * 
 * This program is distributed in the hope that it be useful but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * Xselection.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef SIG_H
#define SIG_H

#include <stddef.h>
#include <signal.h>

extern volatile const sig_atomic_t sig_caught;
extern int sig_fd;
int sig_dfl(int signum);
int sig_dfl_v(const int sigv[], size_t sigc);
int sig_ign(int signum);
int sig_ign_v(const int sigv[], size_t sigc);
int sig_catch(int signum);
int sig_catch_v(const int sigv[], size_t sigc);
int sig_set_v(sigset_t *set, const int sigv[], size_t sigc);
int sig_unblock(int signum);
int sig_unblock_v(const int sigv[], size_t sigc);
int sig_block(int signum);
int sig_block_v(const int sigv[], size_t sigc);
int sig_block_all(void);
int sig_caught_raise(void);
int sig_caught_num_get(int *signum);
ssize_t sig_read(int fd, void *buf, size_t count);
int sig_pend(int signum);
int sig_pend_v(const int sigv[], size_t sigc);

#endif
